#include "p18f2221.h"
#include "p18cxxx.h"
#include "pconfig.h"

// LCD PORT pinout
// PORTC0 = DB4
// PORTC1 = DB5
// PORTC2 = DB6
// PORTC3 = DB7
#define E	PORTCbits.RC7
#define RS	PORTCbits.RC6

void init(void);
void delay(void);
void clk(void);
void WriteLCD(unsigned char row, unsigned char add, unsigned char data);
void WriteFirstRow(void);
void WriteSecondRow(void);
void InitLCD(void);

char FirstRow[16];
char SecondRow[16];

int main(void){
	unsigned char k;
	init();

	FirstRow[0]='H';
	FirstRow[1]='A';
	FirstRow[2]='7';
	FirstRow[3]='W';
	FirstRow[4]='E';
	FirstRow[5]='N';
	FirstRow[6]=' ';
	FirstRow[7]='F';
	FirstRow[8]='I';
	FirstRow[9]='R';
	FirstRow[10]='S';
	FirstRow[11]='T';
	FirstRow[12]=' ';
	FirstRow[13]='L';
	FirstRow[14]='C';
	FirstRow[15]='D';
	WriteFirstRow();

	for(k=0;k<16;k++) SecondRow[k]=k+'0';
	WriteSecondRow();

	while(1);
	
			
}

void init(void){
	PORTC = 0;
	LATC = 0;
	TRISC = 0b00110000;
	InitLCD();
}

void clk(void){	delay(); E=1; delay(); E=0; delay(); }

void delay(void){ unsigned char i; for(i=0;i<50;i++); }

void InitLCD(void){
	unsigned char i;
	// function set
	PORTC=0b00000011;
	clk();
	PORTC=0b00000011;
	clk();
	PORTC=0b00000011;
	clk();
		
	// set interface to 4 bit long
	PORTC=0b00000010;
	clk();

	// 2 lines, 5x7 dots
	PORTC=0b00000010;
	clk();
	PORTC=0b00001100;
	clk();

	// display off
	PORTC=0b00000000;
	clk();
	PORTC=0b00001000;
	clk();

	// display on
	PORTC=0b00000000;
	clk();
	PORTC=0b00001100;
	clk();

	// clear display
	PORTC=0;
	clk();
	PORTC=1;
	clk();
	
	for(i=0;i<16;i++) { FirstRow[i]=' '; SecondRow[i]=' ';	}					
	
}

void WriteLCD(unsigned char row, unsigned char add, unsigned char data){
	unsigned char temp=0;
	// set address
	temp=add/16;
	if(row) PORTC = (temp | 0b00001100) & 0b00001111;
	else PORTC = (temp | 0b00001000) & 0b00001111;
	clk();
	temp=add;
	PORTC=temp&0b00001111;
	clk();
	// write data
	temp=data/16;
	PORTC=(temp&0b00001111)|0b01000000;
	clk();
	temp=data;
	PORTC=(temp&0b00001111)|0b01000000;
	clk();
}

void WriteFirstRow(void){
	unsigned char i;
	for(i=0;i<16;i++) WriteLCD(0,i,FirstRow[i]);
}

void WriteSecondRow(void){
	unsigned char i;
	for(i=0;i<16;i++) WriteLCD(1,i,SecondRow[i]);
}